osgVolume::VolumeTechnique Class Reference

`#include <VolumeTechnique>`

Inheritance diagram for osgVolume::VolumeTechnique:

## Public Member Functions

| VolumeTechnique ()
| VolumeTechnique (const VolumeTechnique &, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgVolume, VolumeTechnique)
VolumeTile * | getVolumeTile ()
const VolumeTile * | getVolumeTile () const
virtual void | init ()
virtual void | update (osgUtil::UpdateVisitor *nv)
virtual bool | isMoving (osgUtil::CullVisitor *nv)
virtual void | cull (osgUtil::CullVisitor *nv)
virtual void | cleanSceneGraph ()
virtual void | traverse (osg::NodeVisitor &nv)
virtual TileData * | createTileData (osgUtil::CullVisitor *)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef std::map< osgUtil::CullVisitor::Identifier *, osg::Matrix > | ModelViewMatrixMap

## Protected Member Functions

void | setDirty (bool dirty)
virtual | ~VolumeTechnique ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

VolumeTile * | _volumeTile
OpenThreads::Mutex | _mutex
ModelViewMatrixMap | _modelViewMatrixMap
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Friends

class | osgVolume::VolumeTile

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Member Typedef Documentation

## ModelViewMatrixMap

typedef std::map<osgUtil::CullVisitor::Identifier*, osg::Matrix> osgVolume::VolumeTechnique::ModelViewMatrixMap

protected

## Constructor & Destructor Documentation

## VolumeTechnique() [1/2]

osgVolume::VolumeTechnique::VolumeTechnique | ( |  | ) |

Referenced by META_Object(), and VolumeTechnique().

## VolumeTechnique() [2/2]

osgVolume::VolumeTechnique::VolumeTechnique | ( | const VolumeTechnique & | ,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References osg::CopyOp::SHALLOW_COPY, and VolumeTechnique().

## ~VolumeTechnique()

virtual osgVolume::VolumeTechnique::~VolumeTechnique | ( |  | ) |

protected virtual

## Member Function Documentation

## cleanSceneGraph()

virtual void osgVolume::VolumeTechnique::cleanSceneGraph | ( |  | ) |

virtual

Clean scene graph from any terrain technique specific nodes.

Reimplemented in osgVolume::FixedFunctionTechnique, osgVolume::MultipassTechnique, and osgVolume::RayTracedTechnique.

## createTileData()

virtual TileData * osgVolume::VolumeTechnique::createTileData | ( | osgUtil::CullVisitor * |  | ) |

inline virtual

Called from VolumeScene to create the TileData container when a multi-pass technique is being used. The TileData container caches any render to texture objects that are required.

Reimplemented in osgVolume::MultipassTechnique.

## cull()

virtual void osgVolume::VolumeTechnique::cull | ( | osgUtil::CullVisitor * | nv | ) |

virtual

Reimplemented in osgVolume::FixedFunctionTechnique, osgVolume::MultipassTechnique, and osgVolume::RayTracedTechnique.

## getVolumeTile() [1/2]

VolumeTile * osgVolume::VolumeTechnique::getVolumeTile | ( |  | ) |

inline

References _volumeTile, and osgVolume::VolumeTile.

## getVolumeTile() [2/2]

const VolumeTile * osgVolume::VolumeTechnique::getVolumeTile | ( |  | ) | const

inline

References _volumeTile, and osgVolume::VolumeTile.

## init()

virtual void osgVolume::VolumeTechnique::init | ( |  | ) |

virtual

Reimplemented in osgVolume::FixedFunctionTechnique, osgVolume::MultipassTechnique, and osgVolume::RayTracedTechnique.

## isMoving()

virtual bool osgVolume::VolumeTechnique::isMoving | ( | osgUtil::CullVisitor * | nv | ) |

virtual

## META_Object()

osgVolume::VolumeTechnique::META_Object | ( | osgVolume | ,
|  | VolumeTechnique | )

References VolumeTechnique().

## setDirty()

void osgVolume::VolumeTechnique::setDirty | ( | bool | dirty | ) |

protected

## traverse()

virtual void osgVolume::VolumeTechnique::traverse | ( | osg::NodeVisitor & | nv | ) |

virtual

Traverse the terrain subgraph.

Reimplemented in osgVolume::FixedFunctionTechnique, osgVolume::MultipassTechnique, and osgVolume::RayTracedTechnique.

## update()

virtual void osgVolume::VolumeTechnique::update | ( | osgUtil::UpdateVisitor * | nv | ) |

virtual

Reimplemented in osgVolume::FixedFunctionTechnique, osgVolume::MultipassTechnique, and osgVolume::RayTracedTechnique.

## Friends And Related Symbol Documentation

## osgVolume::VolumeTile

friend class osgVolume::VolumeTile

friend

Referenced by getVolumeTile(), and getVolumeTile().

## Member Data Documentation

## _modelViewMatrixMap

ModelViewMatrixMap osgVolume::VolumeTechnique::_modelViewMatrixMap

protected

## _mutex

OpenThreads::Mutex osgVolume::VolumeTechnique::_mutex

protected

## _volumeTile

VolumeTile* osgVolume::VolumeTechnique::_volumeTile

protected

Referenced by getVolumeTile(), and getVolumeTile().

The documentation for this class was generated from the following file:

- VolumeTechnique